diff --git a/src/backend/utils/adt/selfuncs.c b/src/backend/utils/adt/selfuncs.c
index ff02b5a..2df6f0e 100644
--- a/src/backend/utils/adt/selfuncs.c
+++ b/src/backend/utils/adt/selfuncs.c
@@ -5592,12 +5592,12 @@ get_quals_from_indexclauses(List *indexclauses)
  * or directly on an indexorderbys list.  In both cases, we expect that the
  * index key expression is on the left side of binary clauses.
  */
-Cost
-index_other_operands_eval_cost(PlannerInfo *root, List *indexquals)
+void
+index_other_operands_eval_cost(PlannerInfo *root, List *indexquals, Cost *qual_arg_cost)
 {
-	Cost		qual_arg_cost = 0;
 	ListCell   *lc;
 
+	cost_zero(qual_arg_cost);
 	foreach(lc, indexquals)
 	{
 		Expr	   *clause = (Expr *) lfirst(lc);
@@ -5641,9 +5641,8 @@ index_other_operands_eval_cost(PlannerInfo *root, List *indexquals)
 		}
 
 		cost_qual_eval_node(&index_qual_cost, other_operand, root);
-		qual_arg_cost += index_qual_cost.startup + index_qual_cost.per_tuple;
+		cost_add2(qual_arg_cost, &index_qual_cost.startup, &index_qual_cost.per_tuple);
 	}
-	return qual_arg_cost;
 }
 
 void
@@ -5665,8 +5664,9 @@ genericcostestimate(PlannerInfo *root,
 	double		num_sa_scans;
 	double		num_outer_scans;
 	double		num_scans;
-	double		qual_op_cost;
-	double		qual_arg_cost;
+	Cost		qual_op_cost;
+	Cost		qual_arg_cost;
+	Cost		tmp;
 	List	   *selectivityQuals;
 	ListCell   *l;
 
@@ -5792,8 +5792,7 @@ genericcostestimate(PlannerInfo *root,
 		 * share for each outer scan.  (Don't pro-rate for ScalarArrayOpExpr,
 		 * since that's internal to the indexscan.)
 		 */
-		indexTotalCost = (pages_fetched * spc_random_page_cost)
-			/ num_outer_scans;
+		cost_add_member_mul_spc(&indexTotalCost, spc_, random_page_cost, pages_fetched/num_outer_scans);
 	}
 	else
 	{
@@ -5801,7 +5800,7 @@ genericcostestimate(PlannerInfo *root,
 		 * For a single index scan, we just charge spc_random_page_cost per
 		 * page touched.
 		 */
-		indexTotalCost = numIndexPages * spc_random_page_cost;
+		cost_add_member_mul_spc(&indexTotalCost, spc_, random_page_cost, numIndexPages);
 	}
 
 	/*
@@ -5818,14 +5817,16 @@ genericcostestimate(PlannerInfo *root,
 	 * Detecting that that might be needed seems more expensive than it's
 	 * worth, though, considering all the other inaccuracies here ...
 	 */
-	qual_arg_cost = index_other_operands_eval_cost(root, indexQuals) +
-		index_other_operands_eval_cost(root, indexOrderBys);
-	qual_op_cost = cpu_operator_cost *
-		(list_length(indexQuals) + list_length(indexOrderBys));
+	index_other_operands_eval_cost(root, indexQuals, &qual_arg_cost);
+	index_other_operands_eval_cost(root, indexOrderBys, &tmp);
+	cost_add(&qual_arg_cost, &tmp);
+
+	cost_set_member_mul(&qual_op_cost, cpu_operator_cost, list_length(indexQuals) + list_length(indexOrderBys));
 
 	indexStartupCost = qual_arg_cost;
-	indexTotalCost += qual_arg_cost;
-	indexTotalCost += numIndexTuples * num_sa_scans * (cpu_index_tuple_cost + qual_op_cost);
+	cost_add(&indexTotalCost, &qual_arg_cost);
+	cost_add_mul(&indexTotalCost, &qual_op_cost, numIndexTuples * num_sa_scans);
+	cost_add_member_mul(&indexTotalCost, cpu_index_tuple_cost, numIndexTuples * num_sa_scans);
 
 	/*
 	 * Generic assumption about index correlation: there isn't any.
@@ -6065,9 +6066,9 @@ btcostestimate(PlannerInfo *root, IndexPath *path, double loop_count,
 	 */
 	if (index->tuples > 1)		/* avoid computing log(0) */
 	{
-		descentCost = ceil(log(index->tuples) / log(2.0)) * cpu_operator_cost;
-		costs.indexStartupCost += descentCost;
-		costs.indexTotalCost += costs.num_sa_scans * descentCost;
+		cost_set_member_mul(&descentCost, cpu_operator_cost, ceil(log(index->tuples) / log(2.0)));
+		cost_add(&costs.indexStartupCost, &descentCost);
+		cost_add_mul(&costs.indexTotalCost, &descentCost, costs.num_sa_scans);
 	}
 
 	/*
@@ -6080,9 +6081,9 @@ btcostestimate(PlannerInfo *root, IndexPath *path, double loop_count,
 	 * touched.  The number of such pages is btree tree height plus one (ie,
 	 * we charge for the leaf page too).  As above, charge once per SA scan.
 	 */
-	descentCost = (index->tree_height + 1) * 50.0 * cpu_operator_cost;
-	costs.indexStartupCost += descentCost;
-	costs.indexTotalCost += costs.num_sa_scans * descentCost;
+	cost_set_member_mul(&descentCost, cpu_operator_cost, (index->tree_height + 1) * 50.0);
+	cost_add(&costs.indexStartupCost, &descentCost);
+	cost_add_mul(&costs.indexTotalCost, &descentCost, costs.num_sa_scans);
 
 	/*
 	 * If we can get an estimate of the first column's ordering correlation C
@@ -6273,17 +6274,17 @@ gistcostestimate(PlannerInfo *root, IndexPath *path, double loop_count,
 	 */
 	if (index->tuples > 1)		/* avoid computing log(0) */
 	{
-		descentCost = ceil(log(index->tuples)) * cpu_operator_cost;
-		costs.indexStartupCost += descentCost;
-		costs.indexTotalCost += costs.num_sa_scans * descentCost;
+		cost_set_member_mul(&descentCost, cpu_operator_cost, ceil(log(index->tuples)));
+		cost_add(&costs.indexStartupCost, &descentCost);
+		cost_add_mul(&costs.indexTotalCost, &descentCost, costs.num_sa_scans);
 	}
 
 	/*
 	 * Likewise add a per-page charge, calculated the same as for btrees.
 	 */
-	descentCost = (index->tree_height + 1) * 50.0 * cpu_operator_cost;
-	costs.indexStartupCost += descentCost;
-	costs.indexTotalCost += costs.num_sa_scans * descentCost;
+	cost_set_member_mul(&descentCost, cpu_operator_cost, (index->tree_height + 1) * 50.0);
+	cost_add(&costs.indexStartupCost, &descentCost);
+	cost_add_mul(&costs.indexTotalCost, &descentCost, costs.num_sa_scans);
 
 	*indexStartupCost = costs.indexStartupCost;
 	*indexTotalCost = costs.indexTotalCost;
@@ -6330,17 +6331,17 @@ spgcostestimate(PlannerInfo *root, IndexPath *path, double loop_count,
 	 */
 	if (index->tuples > 1)		/* avoid computing log(0) */
 	{
-		descentCost = ceil(log(index->tuples)) * cpu_operator_cost;
-		costs.indexStartupCost += descentCost;
-		costs.indexTotalCost += costs.num_sa_scans * descentCost;
+		cost_set_member_mul(&descentCost, cpu_operator_cost, ceil(log(index->tuples)));
+		cost_add(&costs.indexStartupCost, &descentCost);
+		cost_add_mul(&costs.indexTotalCost, &descentCost, costs.num_sa_scans);
 	}
 
 	/*
 	 * Likewise add a per-page charge, calculated the same as for btrees.
 	 */
-	descentCost = (index->tree_height + 1) * 50.0 * cpu_operator_cost;
-	costs.indexStartupCost += descentCost;
-	costs.indexTotalCost += costs.num_sa_scans * descentCost;
+	cost_set_member_mul(&descentCost, cpu_operator_cost, (index->tree_height + 1) * 50.0);
+	cost_add(&costs.indexStartupCost, &descentCost);
+	cost_add_mul(&costs.indexTotalCost, &descentCost, costs.num_sa_scans);
 
 	*indexStartupCost = costs.indexStartupCost;
 	*indexTotalCost = costs.indexTotalCost;
@@ -6658,9 +6659,9 @@ gincostestimate(PlannerInfo *root, IndexPath *path, double loop_count,
 	double		entryPagesFetched,
 				dataPagesFetched,
 				dataPagesFetchedBySel;
-	double		qual_op_cost,
-				qual_arg_cost,
-				spc_random_page_cost,
+	Cost		qual_op_cost,
+				qual_arg_cost;
+	double		spc_random_page_cost,
 				outer_scans;
 	Relation	indexRel;
 	GinStatsData ginStats;
@@ -6815,9 +6816,9 @@ gincostestimate(PlannerInfo *root, IndexPath *path, double loop_count,
 	/* Fall out if there were any provably-unsatisfiable quals */
 	if (!matchPossible)
 	{
-		*indexStartupCost = 0;
-		*indexTotalCost = 0;
-		*indexSelectivity = 0;
+		cost_zero(indexStartupCost);
+		cost_zero(indexTotalCost);
+		indexSelectivity = 0;
 		return;
 	}
 
@@ -6892,7 +6893,7 @@ gincostestimate(PlannerInfo *root, IndexPath *path, double loop_count,
 	 * Here we use random page cost because logically-close pages could be far
 	 * apart on disk.
 	 */
-	*indexStartupCost = (entryPagesFetched + dataPagesFetched) * spc_random_page_cost;
+	cost_set_member_mul_spc(indexStartupCost, spc_, random_page_cost, entryPagesFetched + dataPagesFetched);
 
 	/*
 	 * Now compute the number of data pages fetched during the scan.
@@ -6931,19 +6932,20 @@ gincostestimate(PlannerInfo *root, IndexPath *path, double loop_count,
 	}
 
 	/* And apply random_page_cost as the cost per page */
-	*indexTotalCost = *indexStartupCost +
-		dataPagesFetched * spc_random_page_cost;
+	*indexTotalCost = *indexStartupCost;
+	cost_add_member_mul_spc(indexTotalCost, spc_, random_page_cost, dataPagesFetched);
 
 	/*
 	 * Add on index qual eval costs, much as in genericcostestimate.  But we
 	 * can disregard indexorderbys, since GIN doesn't support those.
 	 */
-	qual_arg_cost = index_other_operands_eval_cost(root, indexQuals);
-	qual_op_cost = cpu_operator_cost * list_length(indexQuals);
+	index_other_operands_eval_cost(root, indexQuals, &qual_arg_cost);
+	cost_set_member_mul(&qual_op_cost, cpu_operator_cost, list_length(indexQuals));
 
-	*indexStartupCost += qual_arg_cost;
-	*indexTotalCost += qual_arg_cost;
-	*indexTotalCost += (numTuples * *indexSelectivity) * (cpu_index_tuple_cost + qual_op_cost);
+	cost_add(indexStartupCost, &qual_arg_cost);
+	cost_add(indexTotalCost, &qual_arg_cost);
+	cost_add_mul(indexTotalCost, &qual_op_cost, *indexSelectivity * numTuples);
+	cost_add_member_mul(indexTotalCost, cpu_index_tuple_cost, *indexSelectivity * numTuples);
 	*indexPages = dataPagesFetched;
 }
 
@@ -6961,9 +6963,9 @@ brincostestimate(PlannerInfo *root, IndexPath *path, double loop_count,
 	double		numPages = index->pages;
 	RelOptInfo *baserel = index->rel;
 	RangeTblEntry *rte = planner_rt_fetch(baserel->relid, root);
-	Cost		spc_seq_page_cost;
-	Cost		spc_random_page_cost;
-	double		qual_arg_cost;
+	double		spc_seq_page_cost;
+	double		spc_random_page_cost;
+	Cost		qual_arg_cost;
 	double		qualSelectivity;
 	BrinStatsData statsData;
 	double		indexRanges;
@@ -7137,23 +7139,23 @@ brincostestimate(PlannerInfo *root, IndexPath *path, double loop_count,
 	 * the index costs.  We can disregard indexorderbys, since BRIN doesn't
 	 * support those.
 	 */
-	qual_arg_cost = index_other_operands_eval_cost(root, indexQuals);
+	index_other_operands_eval_cost(root, indexQuals, &qual_arg_cost);
 
 	/*
 	 * Compute the startup cost as the cost to read the whole revmap
 	 * sequentially, including the cost to execute the index quals.
 	 */
-	*indexStartupCost =
-		spc_seq_page_cost * statsData.revmapNumPages * loop_count;
-	*indexStartupCost += qual_arg_cost;
+	cost_set_member_mul_spc(indexStartupCost,
+		spc_, seq_page_cost, statsData.revmapNumPages * loop_count);
+	cost_add(indexStartupCost, &qual_arg_cost);
 
 	/*
 	 * To read a BRIN index there might be a bit of back and forth over
 	 * regular pages, as revmap might point to them out of sequential order;
 	 * calculate the total cost as reading the whole index in random order.
 	 */
-	*indexTotalCost = *indexStartupCost +
-		spc_random_page_cost * (numPages - statsData.revmapNumPages) * loop_count;
+	*indexTotalCost = *indexStartupCost;
+	cost_add_member_mul_spc(indexTotalCost, spc_, random_page_cost, (numPages - statsData.revmapNumPages) * loop_count);
 
 	/*
 	 * Charge a small amount per range tuple which we expect to match to. This
@@ -7162,8 +7164,8 @@ brincostestimate(PlannerInfo *root, IndexPath *path, double loop_count,
 	 * range, so we must multiply the charge by the number of pages in the
 	 * range.
 	 */
-	*indexTotalCost += 0.1 * cpu_operator_cost * estimatedRanges *
-		statsData.pagesPerRange;
+	cost_add_member_mul(indexTotalCost, cpu_operator_cost, 0.1 * estimatedRanges *
+		statsData.pagesPerRange);
 
 	*indexPages = index->pages;
 }
diff --git a/src/backend/utils/cache/plancache.c b/src/backend/utils/cache/plancache.c
index abc3062..c9b24dd 100644
--- a/src/backend/utils/cache/plancache.c
+++ b/src/backend/utils/cache/plancache.c
@@ -62,6 +62,7 @@
 #include "miscadmin.h"
 #include "nodes/nodeFuncs.h"
 #include "optimizer/optimizer.h"
+#include "optimizer/cost.h"
 #include "parser/analyze.h"
 #include "parser/parsetree.h"
 #include "storage/lmgr.h"
@@ -1082,7 +1083,7 @@ cached_plan_cost(CachedPlan *plan, bool include_planner)
 		if (plannedstmt->commandType == CMD_UTILITY)
 			continue;			/* Ignore utility statements */
 
-		result += plannedstmt->planTree->total_cost;
+		result += cost_asscalar(&plannedstmt->planTree->total_cost);
 
 		if (include_planner)
 		{
diff --git a/src/include/nodes/nodes.h b/src/include/nodes/nodes.h
index bce2d59..f895951 100644
--- a/src/include/nodes/nodes.h
+++ b/src/include/nodes/nodes.h
@@ -656,7 +656,21 @@ extern bool equal(const void *a, const void *b);
  * depend on them...
  */
 typedef double Selectivity;		/* fraction of tuples a qualifier will pass */
-typedef double Cost;			/* execution cost (in page-access units) */
+
+/* execution cost (in page-access units) */
+/* these could be ints to be multipled by associated cost parameter */
+typedef struct {
+	double cpu_index_tuple_cost;
+	double cpu_operator_cost;
+	double cpu_tuple_cost;
+	double parallel_setup_cost;
+	// bool parallel_setup_cost;
+	double parallel_tuple_cost;
+	double random_page_cost;
+	double seq_page_cost;
+	double disable_cost;
+	// bool disable_cost;
+} Cost;
 
 
 /*
diff --git a/src/include/optimizer/cost.h b/src/include/optimizer/cost.h
index b3d0b4f..4a4be15 100644
--- a/src/include/optimizer/cost.h
+++ b/src/include/optimizer/cost.h
@@ -45,7 +45,7 @@ typedef enum
  */
 
 /* parameter variables and flags (see also optimizer.h) */
-extern PGDLLIMPORT Cost disable_cost;
+extern PGDLLIMPORT double disable_cost;
 extern PGDLLIMPORT int max_parallel_workers_per_gather;
 extern PGDLLIMPORT bool enable_seqscan;
 extern PGDLLIMPORT bool enable_indexscan;
@@ -98,8 +98,8 @@ extern void cost_resultscan(Path *path, PlannerInfo *root,
 							RelOptInfo *baserel, ParamPathInfo *param_info);
 extern void cost_recursive_union(Path *runion, Path *nrterm, Path *rterm);
 extern void cost_sort(Path *path, PlannerInfo *root,
-					  List *pathkeys, Cost input_cost, double tuples, int width,
-					  Cost comparison_cost, int sort_mem,
+					  List *pathkeys, Cost *input_cost, double tuples, int width,
+					  Cost *comparison_cost, int sort_mem,
 					  double limit_tuples);
 extern void cost_append(AppendPath *path);
 extern void cost_merge_append(Path *path, PlannerInfo *root,
@@ -113,7 +113,7 @@ extern void cost_agg(Path *path, PlannerInfo *root,
 					 AggStrategy aggstrategy, const AggClauseCosts *aggcosts,
 					 int numGroupCols, double numGroups,
 					 List *quals,
-					 Cost input_startup_cost, Cost input_total_cost,
+					 Cost *input_startup_cost, Cost *input_total_cost,
 					 double input_tuples);
 extern void cost_windowagg(Path *path, PlannerInfo *root,
 						   List *windowFuncs, int numPartCols, int numOrderCols,
@@ -196,5 +196,28 @@ extern void set_foreign_size_estimates(PlannerInfo *root, RelOptInfo *rel);
 extern PathTarget *set_pathtarget_cost_width(PlannerInfo *root, PathTarget *target);
 extern double compute_bitmap_pages(PlannerInfo *root, RelOptInfo *baserel,
 								   Path *bitmapqual, int loop_count, Cost *cost, double *tuple);
+#define cost_add_member(cost,member) (cost)->member += member
+#define cost_add_member_mul(cost,member,mul) (cost)->member += member*mul
+#define cost_add_member_mul_spc(cost,spc,member,mul) (cost)->member += spc##member*mul
+
+#define cost_set_member(cost,member) do{ cost_zero(cost); (cost)->member = member; } while(0);
+#define cost_set_member_mul(cost,member,mul) do{ cost_zero(cost); (cost)->member = member*mul; } while(0);
+#define cost_set_member_mul_spc(cost,spc,member,mul) do{ cost_zero(cost); (cost)->member = spc##member*mul; } while(0);
+#define cost_set_member_add(cost,member,from1) do{ *cost = *from1; (cost)->member += member; } while(0);
+
+extern void cost_zero(Cost *to);
+extern void cost_set_sum2(Cost *to, const Cost *from1, const Cost *from2);
+extern void cost_set_sum3(Cost *to, const Cost *from1, const Cost *from2, const Cost *from3);
+extern void cost_set_diff(Cost *to, const Cost *from1, const Cost *from2);
+extern void cost_add(Cost *to, const Cost *from);
+extern void cost_add2(Cost *to, const Cost *from1, const Cost *from2);
+extern void cost_add_mul(Cost *to, const Cost *from, double multiplier);
+extern void cost_sub(Cost *to, const Cost *from);
+extern void cost_mul_scalar(Cost *to, double by);
+
+/* Comparison */
+extern bool cost_isgt(const Cost *to, const Cost *than);
+extern bool cost_islt(const Cost *to, const Cost *than);
+extern double cost_asscalar(const Cost *to);
 
 #endif							/* COST_H */
diff --git a/src/include/utils/selfuncs.h b/src/include/utils/selfuncs.h
index 353d38a..e08077c 100644
--- a/src/include/utils/selfuncs.h
+++ b/src/include/utils/selfuncs.h
@@ -192,8 +192,9 @@ extern double estimate_hashagg_tablesize(Path *path,
 										 double dNumGroups);
 
 extern List *get_quals_from_indexclauses(List *indexclauses);
-extern Cost index_other_operands_eval_cost(PlannerInfo *root,
-										   List *indexquals);
+extern void index_other_operands_eval_cost(PlannerInfo *root,
+										   List *indexquals,
+										   Cost *qual_arg_cost);
 extern List *add_predicate_to_index_quals(IndexOptInfo *index,
 										  List *indexQuals);
 extern void genericcostestimate(PlannerInfo *root, IndexPath *path,
diff --git a/src/test/regress/regress.c b/src/test/regress/regress.c
index 2f66d76..59f9140 100644
--- a/src/test/regress/regress.c
+++ b/src/test/regress/regress.c
@@ -31,6 +31,7 @@
 #include "executor/spi.h"
 #include "miscadmin.h"
 #include "nodes/supportnodes.h"
+#include "optimizer/cost.h"
 #include "optimizer/optimizer.h"
 #include "optimizer/plancat.h"
 #include "port/atomics.h"
@@ -853,8 +854,8 @@ test_support_func(PG_FUNCTION_ARGS)
 		/* Provide some generic estimate */
 		SupportRequestCost *req = (SupportRequestCost *) rawreq;
 
-		req->startup = 0;
-		req->per_tuple = 2 * cpu_operator_cost;
+		cost_zero(&req->startup);
+		cost_add_member_mul(&req->per_tuple, cpu_operator_cost, 2);
 		ret = (Node *) req;
 	}
 
-- 
2.7.4

